# Orienteer

Open Source Business Application Platform
![Word Clound](http://orienteer.org/images/wordcloud.png)

---

## Key Features

- Open Source
- Docker/Cloud ready
- Rapid Application Development
- Extreme performance
- High integration capabilities
- Pareto principle
    - 80% is Out Of the Box
    - The REST 20% can be easily plugged

---

# Modules

![Modules Screenshot](http://orienteer.org/images/overview/Collage2_cond.png)
---

## Orienteer Core

- Lightweight
- Based on OrientDB: multi-paradigm NoSQL DB
- Powerful security model
- Buil-in localization
- Dashboards/Widgets-based UI
- Dynamic pluggable architecture
- Background processes/tasks
- Docker ready

@fa[arrow-down]

+++
@title[DB Schema]
DB Schema as grid...

![Orienteer grid schema](http://orienteer.org/images/overview/Orienteer_Schema.png)

+++
@title[Schema UML]

...or as graph

![Orienteer graph schema](http://orienteer.org/images/overview/Schema.png)

+++
@title[Dashboards&Widgets]

Dynamic dashboards and widgets

![Orienteer filters](http://orienteer.org/images/overview/dashboard_widgets.png)

+++
@title[Data filtering]

Data filtering

![Orienteer filters](http://orienteer.org/images/overview/orienteer_filters.png)

+++
@title[Modules loading]

Dynamic module loading

![Orienteer modules](http://orienteer.org/images/overview/orienteer_modules.png)

---

## Orienteer Architect

- UML-based editor of data-models
    - Support  of Orienteer specific features
- Rapid Application Development methodology
- Support runtime DB schema changes

@fa[arrow-down]

+++
@title[UML-like editor]

UML-like editor for data modeling

![Architect diagram](http://orienteer.org/images/overview/architect_own_diagram.png)

+++
@title[Create or reuse]

New classes or reuse existing

![Architect use classes](http://orienteer.org/images/overview/architect_use_classes.png)

+++
@title[Applying to DB]

Applying to DB

![Architect save](http://orienteer.org/images/overview/architect_save.png)

---
## Orienteer BIRT

- 2-side integration
    - Adapter for Eclipse BIRT for reports design
    - Module for Orienteer for seamless reports representation
- Fully embedded execution
- Export capabilities

@fa[arrow-down]

+++
@title[Eclipse BIRT]

Prepare report in Eclipse BIRT...

![Camel data](http://orienteer.org/images/overview/birt_eclipse_ss.png)

+++
@title[Orienteer BIRT widget]

...then upload and use it in Orienteer!

![Camel data](http://orienteer.org/images/overview/birt_orienteer_sn.png)

---
## Orienteer BPM

- Seamless embedding of Camunda – Top Business Process Management
- Build-in process definition editor
- Support of user forms
- Seamless integration on scripting level
- Historical data

@fa[arrow-down]

+++?image=http://orienteer.org/images/overview/Orienteer_BPM.png&size=contain
@title[BPM Editor]

---
## Orienteer Camel

- 2-side integration:
    - Adapter for Apache Camel to work with OrientDB and Orienteer
    - Module for Orienteer for Apache Camel specific background tasks
- Easy embedding of integrations with external data sources and data storages
- Support of wide range of OrientDB specific conversions
- Support of streaming integrations

@fa[arrow-down]

+++
@title[Data sample]

Some data to export

![Camel data](http://orienteer.org/images/overview/camel_data_sn.png)

+++
@title[Camel config]

Specify simple camel configuration, press "Run"...

![Camel script](http://orienteer.org/images/overview/camel_script_sn.png)

+++
@title[Camel Task]

... wait for a while ...
![Camel session](http://orienteer.org/images/overview/camel_session_sn.png)

+++
@title[Results in CSV]

...and get CSV file! 

![Camel out](http://orienteer.org/images/overview/camel_out_sn.png)

---
## Orienteer ETL

- Quick and robust loading of data from external data sources
- RDBMs, Files/URLs with JSON/XML, Excel and other data source types
- Multiple steps transformation rules are supported
- Reconciliation or auto-merge is possible

@fa[arrow-down]

+++
@title[Source CSV]

CSV file to import to DB

![Camel out](http://orienteer.org/images/overview/camel_out_sn.png)

+++
@title[OrientDB ETL]

Specify OrientDB ETL configuration, press "Run"...

![ETL Script](http://orienteer.org/images/overview/etl_script_sn.png)

+++
@title[ETL Task]

... wait for a while ...

![ETL Session](http://orienteer.org/images/overview/etl_session_sn.png)

+++
@title[Results in Orienteer]

...and get data in Orienteer!

![ETL result](http://orienteer.org/images/overview/etl_result_sn.png)

---

## Orienteer Dev Utils

- Extended functionality for developers
- Build in consoles for:
    - OrientDB SQL
    - Scripting w/ orienteer context
- Wicket statistics pages for debuging

@fa[arrow-down]

+++?image=http://orienteer.org/images/overview/Orienteer_DevTools_JS.png&size=contain
@title[JavaScript]

+++?image=http://orienteer.org/images/overview/Orienteer_DevTools_SQL.png&size=contain
@title[SQL]

---

## Orienteer Graph

- Module for extended support of OrientDB graph capabilities
    - Graph visualization
    - Graph widgets for vertexes and edges

@fa[arrow-down]

+++?image=http://orienteer.org/images/overview/Graph_viz.png&size=contain
@title[Graph Visualization]

---
## Orienteer Logger Server

- Remote monitoring of incidents
- Contains 2 parts
    - Pure java library for reporting – can be used on Android or any java application
    - Orienteer server-side for analysis
- Flexible reporting fields

@fa[arrow-down]

+++?image=http://orienteer.org/images/overview/Orienteer_Logger.png&size=contain
@title[Logged Incident]

---
## Orienteer Pages

- Lightweight CMS for Orienteer
- Dynamic programming of server/client-side
- REST for one-page applications
- Special tags for easy widgets/properties embedding

---
## Orienteer Pivot Table

- Widget for data pivoting and in-place analysis
- Pre-integrated with Orienteer localization

@fa[arrow-down]

+++?image=http://orienteer.org/images/overview/pivottable.png&size=contain
@title[Simple Pivot]

+++?image=http://orienteer.org/images/overview/PivotTable_barcharts.png&size=contain
@title[Barchart]

---
## Orienteer Taucharts

- Beautiful visualizations for datasets from Orienteer
- Dynamic or preloaded data
- Flexible Taucharts configuration

@fa[arrow-down]

+++?image=http://orienteer.org/images/overview/Taucharts.png&size=contain
@title[Taucharts]

---
## Orienteer Telegram

- MetaBot for building bots to access data in Orienteer
- Localization
- Authentication
- Flexible search
- Paging
- Ability to customize document representation

@fa[arrow-down]

+++?image=http://orienteer.org/images/overview/otelebot.png&size=contain
@title[Dialog]

---
## Resources

- [Official Site](https://orienteer.gitbooks.io/orienteer/content/)
- [Demo Site](https://demo.orienteer.org)
- [GitHub](https://github.com/OrienteerBAP/Orienteer)
- [Blog](https://medium.com/orienteer)
- [Guidebook](https://orienteer.gitbooks.io/orienteer/content/)
- [Wiki](https://github.com/OrienteerBAP/Orienteer/wiki)
- [Docker Image](https://hub.docker.com/r/orienteer/orienteer/)
